=== modified file 'drizzled/generator.h'
--- drizzled/generator.h	2010-07-06 23:50:55 +0000
+++ drizzled/generator.h	2010-07-07 06:52:54 +0000
@@ -18,6 +18,8 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
+#include "drizzled/session.h"
+
 #include "drizzled/generator/schema.h"
 #include "drizzled/generator/table.h"
 #include "drizzled/generator/all_tables.h"

=== modified file 'drizzled/generator/table.cc'
--- drizzled/generator/table.cc	2010-07-02 00:48:31 +0000
+++ drizzled/generator/table.cc	2010-07-07 06:52:54 +0000
@@ -29,15 +29,9 @@
 namespace generator
 {
 
-Table::Table(Session &arg) :
+Table::Table(Session &arg, const SchemaIdentifier &schema_identifier) :
   session(arg)
 {
-  table_iterator= table_names.end();
-}
-
-void Table::reset(const SchemaIdentifier &schema_identifier)
-{
-  table_names.clear();
   plugin::StorageEngine::getTableIdentifiers(session, schema_identifier, table_names);
   table_iterator= table_names.begin();
 }

=== modified file 'drizzled/generator/table.h'
--- drizzled/generator/table.h	2010-07-02 00:48:31 +0000
+++ drizzled/generator/table.h	2010-07-07 06:52:54 +0000
@@ -37,9 +37,7 @@
 
 public:
 
-  Table(Session &arg);
-
-  void reset(const SchemaIdentifier &schema_identifier);
+  Table(Session &arg, const SchemaIdentifier &schema_identifier);
 
   operator const drizzled::message::Table*()
   {

=== added file 'unittests/generators.cc'
--- unittests/generators.cc	1970-01-01 00:00:00 +0000
+++ unittests/generators.cc	2010-07-07 06:52:54 +0000
@@ -0,0 +1,57 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+
+#include <drizzled/generator.h>
+#include <drizzled/plugin/listen.h>
+
+TEST(generator_test, schema)
+{
+  drizzled::Session session(drizzled::plugin::Listen::getNullClient());
+  drizzled::generator::Schema generator(session);
+
+  const drizzled::message::Schema *schema_ptr;
+  if ((schema_ptr= generator))
+    ASSERT_TRUE(0);
+}
+
+TEST(generator_test, table)
+{
+  drizzled::Session session(drizzled::plugin::Listen::getNullClient());
+  drizzled::SchemaIdentifier schema("foo");
+  drizzled::generator::Table generator(session, schema);
+  const drizzled::message::Table *table_ptr;
+
+  if ((table_ptr= generator))
+    ASSERT_TRUE(0);
+}
+
+TEST(generator_test, all_tables)
+{
+  drizzled::Session session(drizzled::plugin::Listen::getNullClient());
+  drizzled::generator::AllTables generator(session);
+  const drizzled::message::Table *table_ptr;
+
+  if ((table_ptr= generator))
+    ASSERT_TRUE(0);
+}

=== modified file 'unittests/include.am'
--- unittests/include.am	2010-06-16 22:09:59 +0000
+++ unittests/include.am	2010-07-07 06:52:54 +0000
@@ -10,11 +10,15 @@
 		  unittests/plugin/plugin_stubs.h \
 		  unittests/temporal_generator.h
 
+unit: unittests/unittests
+	unittests/unittests
+
 unittests_unittests_SOURCES = \
 			      unittests/atomics_test.cc \
 			      unittests/calendar_test.cc \
 			      unittests/date_test.cc \
 			      unittests/date_time_test.cc \
+			      unittests/generators.cc \
 			      unittests/main.cc \
 			      unittests/micro_timestamp_test.cc \
 			      unittests/nano_timestamp_test.cc \

